;
; compute gradients along x and y on grid points T, U, V, lmdzl for any variable

FUNCTION make_grad,  file_name,  ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2, ALL_DATA = all_data

@common
@com_eg

;  Find the position of the comma in the character string defined
;  between '/' in 'fld_macros.def'
   pos_comma = strpos(macro_base_fld,',')

;  Extract the variable and the coordinate along which we want the gradients
   var_name =  strmid(macro_base_fld, 0, pos_comma)
   var_name =  strtrim(var_name, 1)
   var_name =  strcompress(var_name)
   coord_name =  strmid(macro_base_fld, pos_comma + 1, strlen(macro_base_fld) - pos_comma - 1)
   coord_name =  strtrim(coord_name, 1)
   coord_name =  strcompress(coord_name)

;   print, 'Variable and  coordinate'
;   print, var_name,', ', strlen(var_name), ' ,', coord_name, ' ,',strlen(coord_name)

;  Read the variable in the correspondent netcdf file
   var =  nc_read(file_name, var_name,  ncdf_db, TIME_1 = time_1,  TIME_2 =  time_2)

   varname =  var.name
   varunit =  var.units

;  Apply the saxo routine to compute gradients
   gradients =  grad (var.data, coord_name)
   print,  'The vargrid variable after computation of the gradients is ',  vargrid 

;  Define the outputs of the function   
   field = {name: '', data: gradients, legend: '', units: '', origin: '', dim: 0,  direc:'xy'}   
   field.origin = var.origin
   field.dim = var.dim
   
   return, field

END
